import java.io.*;

public class Spellcheck {

    final private static Dictionary mainDict = new Dictionary();
    final private static Dictionary ignored = new Dictionary();

    public static Word checkSpelling(Word w) throws IOException
    {
       while (! mainDict.contains(w) && ! ignored.contains(w)) {
           System.out.println("Unknown word: " + w);
           System.out.print("[1] Add to dictionary, [2] ignore, [3] correct ? ");
           BufferedReader r = new BufferedReader(new InputStreamReader(System.in));
           String c = r.readLine();
           if (c.equals("1")) {
               mainDict.add(w);
           } else if (c.equals("2")) {
               ignored.add(w);
           } else if (c.equals("3")) {
               System.out.print("Add new spelling: ");
               w= new Word(r.readLine());
           } else {
               System.out.println("Your choice is not acceptable.");
           }
       }
       return w;
    }

    public static void processDocument(String inPath, String outPath)
                       throws IOException
    {
        BufferedReader inDoc = new BufferedReader(new FileReader(inPath));
        BufferedWriter outDoc = new BufferedWriter( new FileWriter(outPath));

        try {
            for (;;) {
                Word cw= Word.getWord(inDoc, outDoc);
                cw= checkSpelling(cw);
                cw.putWord(outDoc);
            }
        } catch (EOFException e) {
            inDoc.close();
            outDoc.close();
        }
    }

    public static void main(String[] args)
    {
        try {
             mainDict.load("dictionary.txt");
             processDocument(args[0], args[1]);
             // mainDict.save("dictionary.txt");
        } catch (IOException e) {
            System.out.println("*** ERROR: "+ e);
        }
    }


}
