import java.io.*;
import java.util.Optional;

import static java.lang.Character.isAlphabetic;

public class Word {

  private String word;

  public Word(String spelling) { this.word= spelling; }

  public String toString() { return word; }

  private static Optional<Integer> last= Optional.empty();

  public static Word getWord(BufferedReader inDoc,
                             BufferedWriter outDoc)
                      throws IOException
  {
    // Read next word from inDoc, copy all non-alpha char in between to outDoc.
    int next;
    String b= new String();

    if (last.isPresent()) {
      outDoc.write(last.get());
      last= Optional.empty();
    }

    while (inDoc.ready()) {
      next = inDoc.read();
      if (isAlphabetic(next)) {
        b += (char)next;
      } else {
        if (! b.isEmpty()) {
          last= Optional.of(next);
          return new Word(b);
        }
        outDoc.write(next);
      }
    }
    if (! b.isEmpty()) {
      return new Word(b);
    }
    throw (new EOFException());
  }
 
  public void putWord(BufferedWriter outDoc)  throws IOException
  {
    outDoc.write(word);
  }

}