module Dictionary(
    Dictionary,
    readDictionary,
    writeDictionary,
    contains,
    addSpelling,
    addIgnored
) where

import Prelude hiding(Word)
import Data.Char(toLower)

-- import Data.Set (Set)
import qualified Data.Set as Set

type Word= String

data Dictionary = Dict { main :: Set.Set String 
                       , ignored :: Set.Set String }

readDictionary :: FilePath-> IO Dictionary
readDictionary fp = do
    x <- readFile fp
    let m = foldr Set.insert Set.empty (lines (map toLower x))
    return Dict{main= m, ignored= Set.empty}

writeDictionary :: Dictionary-> FilePath-> IO ()
writeDictionary d fp = 
    writeFile fp (unlines (Set.elems (main d)))

contains :: Dictionary-> Word-> Bool 
contains d w = Set.member (map toLower w) (main d) || Set.member w (ignored d)   

addSpelling :: Dictionary-> Word-> Dictionary
addSpelling d w = d{main= Set.insert (map toLower w) (main d)}

addIgnored :: Dictionary-> Word-> Dictionary
addIgnored d w = d{ignored= Set.insert (map toLower w) (ignored d)}
