module Words(
    Word
  , Chunk(..)
  , chunks
  , unchunk
) where

import Prelude hiding (Word)
import Data.Char(isAlpha)
import Data.List.Split(condense, whenElt, split)   
type Word = String

data Chunk = NonWord { string :: String } 
           | Word { string :: Word } deriving Show

chunk :: String-> Chunk
chunk cs = if isAlpha (head cs) then Word cs else NonWord cs

chunks :: String-> [Chunk] 
chunks = map chunk . filter (not.null) . split (condense $ whenElt (not.isAlpha))

unchunk :: [Chunk]-> String
unchunk = concatMap string
